#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#define EXTERN
#include "globalc.h"
#include "global.h"
#include "globalt.h"
#include "solverc.h"
#include "metrinit.h"

#include "seqfilesm.h"
#include "seqfilest.h"


int main (int argc, const char *argv[])
{
  time_t bt,et;
  long hod,min;
  double sec = clock();
  
  setvbuf(stdout, NULL, _IONBF, 0);
  setvbuf(stderr, NULL, _IONBF, 0);

  bt = time (NULL);
  
  //  program initiation and data reading
  metr_init (argc,argv);
  
  //  solution of the problem
  //  the most important function in the code
  solve_metr_problem ();


  et = time (NULL);
  fprintf (Outc,"\n\n\n Data about computation time \n");
  fprintf (Outc,"\n\n Total time of computation             %ld",long(et-bt));

  sec = (clock() - sec) / (double)CLOCKS_PER_SEC;
  hod = (long)sec/3600;  sec -= hod*3600;
  min = (long)sec/60;    sec -= min*60;
  fprintf (stdout,"\n ----------------------------------");
  fprintf (stdout,"\n Consumed time by METR %2ld:%02ld:%05.2f",hod,min,sec);
  fprintf (stdout,"\n ----------------------------------\n");
  
  
  fprintf (stdout,"\n\n");  fprintf (stderr,"\n\n");  fprintf (Outc,"\n");
  fclose (Out);
  fclose (Outt);
  fclose (Outc);  
  
  //METR:

  delete Cp;

  delete Ct;
  delete Cmu;
  delete Cml;
  delete Cb;
  delete Lsrsc;
  delete Outdc;
  delete Gtu;
  delete [] TM_ip;
  delete [] MT_ip;


  //MEFEL:
  delete Mp;
  delete Mt;
  delete Mm;
  delete Mc;
  delete Mb;
  delete Gtm;

  delete Lsrs;
  delete Ada;
  delete St;
  delete Outdm;
  delete Fsd;

  delete Smat;
  delete Mmat;
  delete Dmat; 
  delete Ismat;
  delete Amat;

  delete Bar2d;
  delete Barq2d;
  delete Bar3d;
  delete Barq3d;
  delete Beam2d;
  delete Beam3d;
  delete Spring;
  delete Pelt;
  delete Peqt;
  delete Perlt;
  delete Pelq;
  delete Peqq;
  delete Perlq;
  delete Pesqt;
  delete Cct;
  delete Dkt;
  delete Dst;
  delete Q4pl;
  delete Asymlq;
  delete Asymqq;
  delete Asymlt;
  delete Shtr;
  delete Shq;
  delete Ltet;
  delete Lhex;
  delete Qhex;
  delete Spltr;
  delete Splq;

 //TRFEL:
  delete Tt;
  delete Tm;
  delete Tc;
  delete Tb;
  delete Gtt;
  delete Tp;

  delete Lsrst;
  delete Outdt;

  delete Kmat;
  delete Cmat;
  delete Lbt;
  delete Lbat;
  delete Qbt;
  delete Qbat;
  delete Ltt;
  delete Ltat;
  delete Lqt;
  delete Qqt;
  delete Qqat;
  delete Lqat;
  delete Ltett;
  delete Lht;
  delete Qht;


  return 0;
}
